package fr.unice.reneviergonin.demoreco;

import android.app.Activity;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.content.pm.ResolveInfo;
import android.graphics.Color;
import android.os.Bundle;
import android.speech.RecognizerIntent;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;

import java.util.ArrayList;
import java.util.List;


public class DemoReco extends Activity {

    EditText text;
    private static final int VOICE_RECOGNITION_REQUEST_CODE = 007;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_demo_reco);

        // Get displayed items for later interaction
        Button speakButton = (Button) findViewById(R.id.button);

        // Check to see if a recognition activity is present
        PackageManager pm = getPackageManager();
        Intent intent = new Intent(RecognizerIntent.ACTION_RECOGNIZE_SPEECH);
        List<ResolveInfo> activities = pm.queryIntentActivities(intent , 0);
        if (activities.size() == 0) {
            speakButton.setEnabled(false);
            speakButton.setText("Recognizer not present");
        }

        text = (EditText) findViewById(R.id.text);
    }


    // listener du bouton, association faite dans le layout xml
    public void startVoiceRecognitionActivity(View view) {
        Intent intent = new Intent(RecognizerIntent.ACTION_RECOGNIZE_SPEECH);
        // intent.putExtra(RecognizerIntent.EXTRA_LANGUAGE_MODEL,"fr-FR");
        intent.putExtra(RecognizerIntent.EXTRA_LANGUAGE_MODEL, RecognizerIntent.LANGUAGE_MODEL_FREE_FORM);
        intent.putExtra(RecognizerIntent.EXTRA_PROMPT, "Speech recognition demo");
        startActivityForResult(intent, VOICE_RECOGNITION_REQUEST_CODE);
    }

    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        // en cas de reponse de la reconnaissance vocale...
        if (requestCode == VOICE_RECOGNITION_REQUEST_CODE && resultCode == RESULT_OK) {
            ArrayList<String> matches = data.getStringArrayListExtra(RecognizerIntent.EXTRA_RESULTS);

            int nb_rep = matches.size();
            if (nb_rep > 0)
            {
                int nb_test = Math.min(3, nb_rep);

                // on regarde jusqu'à 3 réponses données par la reco
                for(int i = 0; i < nb_test; i++)
                {
                    text.append("\nmessage reconnu : " + matches.get(0));
                    if (matches.get(0).toLowerCase().equals("jaune") || matches.get(0).toLowerCase().equals("poussin") )
                    {
                        text.setBackgroundColor(Color.YELLOW);
                        break;
                    }
                    else  if (matches.get(0).toLowerCase().equals("rouge"))
                    {
                        text.setBackgroundColor(Color.RED);
                        break;
                    }
                    else if (matches.get(0).toLowerCase().equals("bleu"))
                    {
                        text.setBackgroundColor(Color.BLUE);
                        break;
                    }
                    else  if (matches.get(0).toLowerCase().equals("blanc"))
                    {
                        text.setBackgroundColor(Color.WHITE);
                        break;
                    }
                    else  if (matches.get(0).toLowerCase().equals("violet"))
                    {
                        text.setBackgroundColor( Color.argb (255,255,0,255));
                        break;
                    }
                    else  if (matches.get(0).toLowerCase().equals("plus gros"))
                    {
                        text.setTextSize(text.getTextSize()+1f);
                        break;
                    }
                    else  if (matches.get(0).toLowerCase().equals("plus petit"))
                    {
                        text.setTextSize(text.getTextSize()-1f);
                        break;
                    }
                }
            }
        }

        super.onActivityResult(requestCode, resultCode, data);
    }
}
